#include <sourcemod>
#include <sdktools>
#include <tf2>
#include <tf2_stocks>

#define PLUGIN_VERSION  "1.1"

public Plugin:myinfo = 
{
	name = "RCBOT2 Spy And Cart Locomotion Fix",
	author = "EfeDursun125",
	description = "RCBot2 spies now not trying backstab on cloaked.",
	version = PLUGIN_VERSION,
	url = "https://steamcommunity.com/id/EfeDursun91/"
}

new g_iOffsetCloak;

Float:moveForward(Float:vel[3],Float:MaxSpeed)
{
	vel[0] = MaxSpeed;
	return vel;
}

Float:moveBackwards(Float:vel[3],Float:MaxSpeed)
{
	vel[0] = -MaxSpeed;
	return vel;
}

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3])
{
	if(IsValidClient(client))
	{
		if(IsFakeClient(client))
		{
			if(IsPlayerAlive(client))
			{
				new TFClassType:class = TF2_GetPlayerClass(client);
				
				if(class == TFClass_Spy)
				{
					for (new search = 1; search <= MaxClients; search++)
					{
						if (IsClientInGame(search) && IsPlayerAlive(search) && search != client && (GetClientTeam(client) != GetClientTeam(search)))
						{
							new Float:clientOrigin[3];
							new Float:searchOrigin[3];
							GetClientAbsOrigin(search, searchOrigin);
							GetClientAbsOrigin(client, clientOrigin);
							
							new TFClassType:otherclass = TF2_GetPlayerClass(search);

							new Float:chainDistance2;
							chainDistance2 = GetVectorDistance(clientOrigin, searchOrigin);

							if(chainDistance2 < 200.0 && IsWeaponSlotActive(client, 2) && GetEntProp(GetPlayerWeaponSlot(client, TFWeaponSlot_Melee), Prop_Send, "m_bReadyToBackstab") && otherclass != TFClass_Spy)
							{
								vel = moveForward(vel,300.0);
							}
							else if(chainDistance2 < 85.0 && otherclass != TFClass_Spy)
							{
								vel = moveBackwards(vel,300.0);
							}
							
							if(chainDistance2 < 300.0 && TF2_IsPlayerInCondition(search, TFCond_Cloaked))
							{
								vel = moveBackwards(vel,300.0);
							}
							
							if(chainDistance2 < 200.0 && IsWeaponSlotActive(client, 2) && GetEntProp(GetPlayerWeaponSlot(client, TFWeaponSlot_Melee), Prop_Send, "m_bReadyToBackstab") && otherclass != TFClass_Spy)
							{
								if(class == TFClass_Spy && buttons & IN_FORWARD)
								{
									buttons &= ~IN_BACK;
								}
							}
							else if(chainDistance2 < 90.0 && otherclass != TFClass_Spy)
							{
								if(class == TFClass_Spy && buttons & IN_FORWARD)
								{
									buttons &= ~IN_FORWARD;
								}
							}
							
							if(chainDistance2 < 300.0 && TF2_IsPlayerInCondition(search, TFCond_Cloaked))
							{
								if(class == TFClass_Spy && buttons & IN_FORWARD)
								{
									buttons &= ~IN_FORWARD;
								}
							}
							
							if(chainDistance2 < 100.0 && otherclass == TFClass_Spy && IsWeaponSlotActive(client, 2) && !TF2_IsPlayerInCondition(search, TFCond_Cloaked))
							{
								new random = GetRandomInt(1,2);
								switch(random)
								{
									case 1:
									{
										buttons |= IN_ATTACK;
									}
									case 2:
									{
										buttons |= IN_ATTACK2;
									}
								}
							}
						}
					}
				}
				
				if(class == TFClass_Spy)
				{
					if(IsWeaponSlotActive(client, 2) && GetEntProp(GetPlayerWeaponSlot(client, TFWeaponSlot_Melee), Prop_Send, "m_bReadyToBackstab") && !TF2_IsPlayerInCondition(client, TFCond_Cloaked))
					{
						buttons |= IN_ATTACK;
					}
				}
				
				if(class == TFClass_Spy && buttons & IN_ATTACK2 && GetHealth(client) > 100.0 && !TF2_IsPlayerInCondition(client, TFCond_Cloaked) && TF2_IsPlayerInCondition(client, TFCond_Disguised))
				{
					buttons &= ~IN_ATTACK2;
				}
				
				if(class == TFClass_Spy && GetHealth(client) < 75.0 && !TF2_IsPlayerInCondition(client, TFCond_Cloaked) && !TF2_IsPlayerInCondition(client, TFCond_Disguised))
				{
					buttons |= IN_ATTACK2;
				}
				
				if(TF2_IsPlayerInCondition(client, TFCond_Taunting))
				{
					vel = moveForward(vel,300.0);
				}
				
				if(class == TFClass_Spy && TF2_IsPlayerInCondition(client, TFCond_Cloaked))
				{
					g_iOffsetCloak = FindSendPropInfo("CTFPlayer", "m_flCloakMeter");
					SetEntDataFloat(client, g_iOffsetCloak, 100.0);
				}
				
				if(class == TFClass_Spy && TF2_IsPlayerInCondition(client, TFCond_DeadRingered))
				{
					g_iOffsetCloak = FindSendPropInfo("CTFPlayer", "m_flCloakMeter");
					SetEntDataFloat(client, g_iOffsetCloak, 100.0);
				}
			}
		}
	}
	
	return Plugin_Continue;
}

stock GetHealth(client)
{
	return GetEntProp(client, Prop_Send, "m_iHealth");
}

stock bool:IsWeaponSlotActive(iClient, iSlot)
{
    return GetPlayerWeaponSlot(iClient, iSlot) == GetEntPropEnt(iClient, Prop_Send, "m_hActiveWeapon");
}

bool:IsValidClient( client ) 
{
    if ( !( 1 <= client <= MaxClients ) || !IsClientInGame(client) ) 
        return false; 
     
    return true; 
}
  